// import QtQuick 1.0 // to target S60 5th Edition or Maemo 5
import QtQuick 1.1

Item
{
    id : item_browser
    property string selectedName;
    property bool   clearView : false;
    property bool   showPic : false;
    property alias source : loader_browser.source;
    property string filename_loader;
    property variant filterSearch_loader;
    property int cellHeight;
    property int cellWidth;

    Loader
    {
        id : loader_browser
        anchors.fill: parent
        function getWidth() {return item_browser.width}
        function getHeight() {return item_browser.height}
        function getFilename() {return item_browser.filename_loader}
        function getFilterSearch() {return item_browser.filterSearch_loader}
        function getCellWidth() {return item_browser.cellWidth}
        function getCellHeight() {return item_browser.cellHeight}
        function getX() {return item_browser.x}
        function getY() {return item_browser.y}
        function getShowPic() {return item_browser.showPic}
    }

    Connections
    {
        target : loader_browser.item
        onSelectedFile :
        {

            console.log("Loader Received select " +  file)
            //item_browser.fileSelected(file);
            selectedName = file;
        }
    }
    Connections
    {
        target : loader_browser.item
        onClearView : clearView = cViewBool;
    }
}
